//------------------------------
//Align Axis - By Samuel Kvaalen
//Aligns all selected points to the last or first selected point on the wanted axes.

@version 2.2
@warnings
@script modeler
@name "Align Axis"

main
{

pth = getdir(INSTALLDIR);

sz = size(pth);
flnm = strleft(pth,sz+(-9));

flnm = flnm+"\\AlignAxis.txt";

file = File(flnm, "r");

if(file)
{
    var1 = file.readInt();
    var2 = file.readInt();
    var3 = file.readInt();
    var4 = file.readInt();
    var5 = file.readInt();
}
else
{
    var1 = 1;
    var2 = 1;
    var3 = 1;
    var4 = 2;
    var5 = 0;
}

    reqbegin("Align Axis");

    c0 = ctlcheckbox("X",var1);
    c1 = ctlcheckbox("Y",var2);
    c2 = ctlcheckbox("Z",var3);
    c3 = ctlchoice("Align to point",var4,@"First","Last"@);
    c4 = ctlcheckbox("Merge Points",var5);

    return if !reqpost();

    Xa = getvalue(c0);
    Ya = getvalue(c1);
    Za = getvalue(c2);
    P = getvalue(c3);
    M = getvalue(c4);

    reqend();

pth = getdir(INSTALLDIR);

sz = size(pth);
flnm = strleft(pth,sz+(-9));

flnm = flnm+"\\AlignAxis.txt";

file = File(flnm, "w");
file.writeln(Xa);
file.writeln(Ya);
file.writeln(Za);
file.writeln(P);
file.writeln(M);

selmode(USER);

editbegin();
pc = pointcount();

if(!pc)
    error("You have to select some points");

if(pc==1)
    return;

if(P==1)
    val = pointinfo(points[1]);
else
    val = pointinfo(points[pc]);

for(i=1;i<=pc;i++)
{
    CurVal = pointinfo(points[i]);

if(Xa)
    pointmove(points[i],<val.x,CurVal.y,CurVal.z>);
if(Ya)
    pointmove(points[i],<CurVal.x,val.y,CurVal.z>);
if(Za)
    pointmove(points[i],<CurVal.x,CurVal.y,val.z>);

}

editend();

if(M) {mergepoints();}

}
